Index: /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_qck.F90
===================================================================
--- /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 790)
+++ /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_qck.F90	(revision 791)
@@ -523,9 +448,19 @@
 
 
-   REAL FUNCTION bound(fu,fd,fc,fho)
-      REAL(wp) ::  fu, fd, fc, fho, fref1, fref2
-      fref1 = fu
-      fref2 = MAX(  MIN( fc , fd ), MIN( MAX( fc , fd ), fref1 )  )
-      bound = MAX(  MIN( fho, fc ), MIN( MAX( fho, fc ), fref2 )  )
+   FUNCTION bound( pfu, pfd, pfc, pfho )   RESULT( pbound )
+      !!----------------------------------------------------------------------
+      !!                  ***  FUNCTION bound  ***
+      !!
+      !! ** Purpose :   ???
+      !!----------------------------------------------------------------------
+      REAL(wp), INTENT(in) ::  pfu, pfd, pfc, pfho
+      REAL(wp)             ::  pbound
+      !!
+      REAL(wp) ::  zfref1, zfref2
+      !!----------------------------------------------------------------------
+      zfref1 = pfu
+      zfref2 = MAX(  MIN( pfc , pfd ), MIN( MAX( pfc , pfd ), zfref1 )  )
+      pbound = MAX(  MIN( pfho, pfc ), MIN( MAX( pfho, pfc ), zfref2 )  )
+      !
    END FUNCTION
 
Index: /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_tvd.F90
===================================================================
--- /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_tvd.F90	(revision 790)
+++ /branches/dev_001_GM/NEMO/OPA_SRC/TRA/traadv_tvd.F90	(revision 791)
@@ -4,14 +4,14 @@
    !! Ocean active tracers:  horizontal & vertical advective trend
    !!==============================================================================
-   !! History :  7.0  !  95-12  (L. Mortier)  Original code
-   !!            8.0  !  00-01  (H. Loukos)  adapted to ORCA 
-   !!             -   !  00-10  (MA Foujols E.Kestenare)  include file not routine
-   !!             -   !  00-12  (E. Kestenare M. Levy)  fix bug in trtrd indexes
-   !!             -   !  01-07  (E. Durand G. Madec)  adaptation to ORCA config
-   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!   NEMO     1.0  !  04-01  (A. de Miranda, G. Madec, J.M. Molines ): advective bbl
-   !!             -   !  08-04  (S. Cravatte) add the i-, j- & k- trends computation
-   !!             -   !  05-11  (V. Garnier) Surface pressure gradient organization
-   !!            2.4  !  08-01  (G. Madec) Merge TRA-TRC
+   !! History :  7.0  !  1995-12  (L. Mortier)  Original code
+   !!            8.0  !  2000-01  (H. Loukos)  adapted to ORCA 
+   !!             -   !  2000-10  (MA Foujols E.Kestenare)  include file not routine
+   !!             -   !  2000-12  (E. Kestenare M. Levy)  fix bug in trtrd indexes
+   !!             -   !  2001-07  (E. Durand G. Madec)  adaptation to ORCA config
+   !!            8.5  !  2002-06  (G. Madec)  F90: Free form and module
+   !!   NEMO     1.0  !  2004-01  (A. de Miranda, G. Madec, J.M. Molines ): advective bbl
+   !!             -   !  2008-04  (S. Cravatte) add the i-, j- & k- trends computation
+   !!             -   !  2005-11  (V. Garnier) Surface pressure gradient organization
+   !!            2.4  !  2008-01  (G. Madec)  merge TRC-TRA + switch from velocity to transport
    !!----------------------------------------------------------------------
 
@@ -42,5 +42,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OPA 2.4 , LOCEAN-IPSL (2008) 
-   !! $Id:$ 
+   !! $Id$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
@@ -70,11 +70,9 @@
       REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pta             ! tracer trend 
       !!
-      INTEGER  ::   ji, jj, jk              ! dummy loop indices
-      REAL(wp) ::   ztai, ztaj, ztak
-      REAL(wp) ::   z2dtt, zbtr, zeu, zev   ! temporary scalar
-      REAL(wp) ::   zew, z2                          ! temporary scalar
-      REAL(wp) ::   zfp_ui, zfp_vj, zfp_wk           !    "         "
-      REAL(wp) ::   zfm_ui, zfm_vj, zfm_wk            !    "         "
-      REAL(wp), DIMENSION (jpi,jpj,jpk) ::   zti, ztu, ztv, ztw   ! temporary workspace
+      INTEGER  ::   ji, jj, jk               ! dummy loop indices
+      REAL(wp) ::   z2dtt, zbtr, z2, zzti    ! temporary scalar
+      REAL(wp) ::   zfp_ui, zfp_vj, zfp_wk   !    "         "
+      REAL(wp) ::   zfm_ui, zfm_vj, zfm_wk   !    "         "
+      REAL(wp), DIMENSION (jpi,jpj,jpk) ::   zti, ztu, ztv, ztw   ! 3D workspace
       !!----------------------------------------------------------------------
 
@@ -87,6 +85,6 @@
       ENDIF
 
-      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;    z2 = 1.
-      ELSE                                        ;    z2 = 2.
+      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;    z2 = 1.      ! euler   time-stepping
+      ELSE                                        ;    z2 = 2.      ! leap-frog time-stepping
       ENDIF
 
@@ -103,54 +101,51 @@
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-               zeu = 0.5 * e2u(ji,jj) * fse3u(ji,jj,jk) * pun(ji,jj,jk)
-               zev = 0.5 * e1v(ji,jj) * fse3v(ji,jj,jk) * pvn(ji,jj,jk)
-               ! upstream scheme
-               zfp_ui = zeu + ABS( zeu )
-               zfm_ui = zeu - ABS( zeu )
-               zfp_vj = zev + ABS( zev )
-               zfm_vj = zev - ABS( zev )
-               ztu(ji,jj,jk) = zfp_ui * ptb(ji,jj,jk) + zfm_ui * ptb(ji+1,jj  ,jk)
-               ztv(ji,jj,jk) = zfp_vj * ptb(ji,jj,jk) + zfm_vj * ptb(ji  ,jj+1,jk)
-            END DO
-         END DO
-      END DO
-
+               zfp_ui = pun(ji,jj,jk) + ABS( pun(ji,jj,jk) )
+               zfm_ui = pun(ji,jj,jk) - ABS( pun(ji,jj,jk) )
+               zfp_vj = pvn(ji,jj,jk) + ABS( pvn(ji,jj,jk) )
+               zfm_vj = pvn(ji,jj,jk) - ABS( pvn(ji,jj,jk) )
+               ztu(ji,jj,jk) = 0.5 * ( zfp_ui * ptb(ji,jj,jk) + zfm_ui * ptb(ji+1,jj  ,jk) )
+               ztv(ji,jj,jk) = 0.5 * ( zfp_vj * ptb(ji,jj,jk) + zfm_vj * ptb(ji  ,jj+1,jk) )
+            END DO
+         END DO
+      END DO
+      !
       ! upstream tracer flux in the k direction
-      ! Surface value
-      IF( lk_dynspg_rl .OR. lk_vvl ) THEN               ! rigid lid or variable volume: flux set to zero
-         ztw(:,:,1) = 0.e0
-      ELSE                                              ! free surface
-         ztw(:,:,1) = e1t(:,:) * e2t(:,:) * pwn(:,:,1) * ptb(:,:,1)
-      ENDIF
-
-      ! Interior value
-      DO jk = 2, jpkm1
+      !                                                                           ! Surface value
+      IF( lk_dynspg_rl .OR. lk_vvl ) THEN   ;   ztw(:,:,1) = 0.e0                      ! rigid lid or non-linear fs
+      ELSE                                  ;   ztw(:,:,1) = pwn(:,:,1) * ptb(:,:,1)   ! free surface
+      ENDIF
+      !
+      DO jk = 2, jpkm1                                                            ! Interior value
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zew = 0.5 * e1t(ji,jj) * e2t(ji,jj) * pwn(ji,jj,jk)
-               zfp_wk = zew + ABS( zew )
-               zfm_wk = zew - ABS( zew )
-               ztw(ji,jj,jk) = zfp_wk * ptb(ji,jj,jk) + zfm_wk * ptb(ji,jj,jk-1)
-            END DO
-         END DO
-      END DO
-
-      ! total advective trend
-      DO jk = 1, jpkm1
+               zfp_wk = pwn(ji,jj,jk) + ABS( pwn(ji,jj,jk) )
+               zfm_wk = pwn(ji,jj,jk) - ABS( pwn(ji,jj,jk) )
+               ztw(ji,jj,jk) = 0.5 * ( zfp_wk * ptb(ji,jj,jk) + zfm_wk * ptb(ji,jj,jk-1) )
+            END DO
+         END DO
+      END DO
+      !
+      ! upstream advective trend
+      DO jk = 1, jpkm1
+         z2dtt = z2 * rdttra(jk)
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
                zbtr = 1./ ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-               ! i- j- horizontal & k- vertical advective trends
-               ztai = - ( ztu(ji,jj,jk) - ztu(ji-1,jj  ,jk  ) ) * zbtr
-               ztaj = - ( ztv(ji,jj,jk) - ztv(ji  ,jj-1,jk  ) ) * zbtr
-               ztak = - ( ztw(ji,jj,jk) - ztw(ji  ,jj  ,jk+1) ) * zbtr
                ! total intermediate advective trends
-               zti(ji,jj,jk) = ztai + ztaj + ztak
-            END DO
-         END DO
-      END DO
-
-      !  Save the horizontal advective trends for diagnostic
-      ! -----------------------------------------------------
+               zzti = - ( ztu(ji,jj,jk) - ztu(ji-1,jj  ,jk  )            &
+                  &     + ztv(ji,jj,jk) - ztv(ji  ,jj-1,jk  )            &
+                  &     + ztw(ji,jj,jk) - ztw(ji  ,jj  ,jk+1) ) * zbtr
+               ! update and guess with monotonic sheme
+               pta(ji,jj,jk) =   pta(ji,jj,jk) +         zzti
+               zti(ji,jj,jk) = ( ptb(ji,jj,jk) + z2dtt * zzti ) * tmask(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      !
+      CALL lbc_lnk( zti, 'T', 1. )      ! Lateral boundary conditions on zti   (unchanged sign)
+
+
+      !                                 ! trend diagnostics (contribution of upstream fluxes)
       IF( l_trdtra ) THEN
          CALL trd_tra_adv( kt, ktra, jpt_trd_xad, cdtype, ztu, pun, ptn )
@@ -158,90 +153,66 @@
          CALL trd_tra_adv( kt, ktra, jpt_trd_zad, cdtype, ztw, pwn, ptn )
       ENDIF
-
-      ! update and guess with monotonic sheme
-      DO jk = 1, jpkm1
-         z2dtt = z2 * rdttra(jk)
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               pta(ji,jj,jk) =  pta(ji,jj,jk) + zti(ji,jj,jk)
-               zti (ji,jj,jk) = ( ptb(ji,jj,jk) + z2dtt * zti(ji,jj,jk) ) * tmask(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-
-      ! Lateral boundary conditions on zti   (unchanged sign)
-      CALL lbc_lnk( zti, 'T', 1. )
+      !                                 ! "Poleward" heat and salt transports (contribution of upstream fluxes)
+      IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
+         IF( ktra == jp_tem)   pht_adv(:) = ptr_vj( ztv(:,:,:) ) 
+         IF( ktra == jp_sal)   pst_adv(:) = ptr_vj( ztv(:,:,:) )
+      ENDIF
 
 
       ! 3. antidiffusive flux : high order minus low order
       ! --------------------------------------------------
-      ! antidiffusive flux on i and j
+      !                                 ! anti-diffusive flux on i and j
       DO jk = 1, jpkm1
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
-               zeu = 0.5 * e2u(ji,jj) * fse3u(ji,jj,jk) * pun(ji,jj,jk)
-               zev = 0.5 * e1v(ji,jj) * fse3v(ji,jj,jk) * pvn(ji,jj,jk)
-               ztu(ji,jj,jk) = zeu * ( ptn(ji,jj,jk) + ptn(ji+1,jj,jk) ) - ztu(ji,jj,jk)
-               ztv(ji,jj,jk) = zev * ( ptn(ji,jj,jk) + ptn(ji,jj+1,jk) ) - ztv(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-      
-      ! antidiffusive flux on k
-      ! Surface value
-      ztw(:,:,1) = 0.e0
-
-      ! Interior value
-      DO jk = 2, jpkm1
+               ztu(ji,jj,jk) = 0.5 * pun(ji,jj,jk) * ( ptn(ji,jj,jk) + ptn(ji+1,jj,jk) ) - ztu(ji,jj,jk)
+               ztv(ji,jj,jk) = 0.5 * pvn(ji,jj,jk) * ( ptn(ji,jj,jk) + ptn(ji,jj+1,jk) ) - ztv(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      !                                 ! antidiffusive flux on k
+      ztw(:,:,1) = 0.e0                      ! Surface value
+      !
+      DO jk = 2, jpkm1                       ! Interior value
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zew = 0.5 * e1t(ji,jj) * e2t(ji,jj) * pwn(ji,jj,jk)
-               ztw(ji,jj,jk) = zew * ( ptn(ji,jj,jk) + ptn(ji,jj,jk-1) ) - ztw(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-
-      ! Lateral bondary conditions
-      CALL lbc_lnk( ztu, 'U', -1. )
+               ztw(ji,jj,jk) = 0.5 * pwn(ji,jj,jk) * ( ptn(ji,jj,jk) + ptn(ji,jj,jk-1) ) - ztw(ji,jj,jk)
+            END DO
+         END DO
+      END DO
+      !
+      CALL lbc_lnk( ztu, 'U', -1. )     ! Lateral bondary conditions on upstream fluxes
       CALL lbc_lnk( ztv, 'V', -1. )
       CALL lbc_lnk( ztw, 'W',  1. )
 
-      ! 4. monotonicity algorithm
-      ! -------------------------
+      !                                 ! monotonicity algorithm
       CALL nonosc( ptb, ztu, ztv, ztw, zti, z2 )
 
 
-      ! 5. final trend with corrected fluxes
-      ! ------------------------------------
+      ! 4. final trend with anti-diffusive fluxes
+      ! -----------------------------------------
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.  
                zbtr = 1. / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
-               ! i- j- horizontal & k- vertical advective trends
-               ztai = - ( ztu(ji,jj,jk) - ztu(ji-1,jj  ,jk  )) * zbtr
-               ztaj = - ( ztv(ji,jj,jk) - ztv(ji  ,jj-1,jk  )) * zbtr
-               ztak = - ( ztw(ji,jj,jk) - ztw(ji  ,jj  ,jk+1)) * zbtr
-
-               ! add them to the general tracer trends
-               pta(ji,jj,jk) = pta(ji,jj,jk) + ztai + ztaj + ztak
-            END DO
-         END DO
-      END DO
-
-!!gm  the transport computation is wrong, the upstream part is missing !
-      ! "zonal" mean advective heat and salt transport
-      IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
-         IF( ktra == jp_tem)   pht_adv(:) = ptr_vj( ztv(:,:,:) )
-         IF( ktra == jp_sal)   pst_adv(:) = ptr_vj( ztv(:,:,:) )
-      ENDIF
-
-      !  Save the horizontal advective trends for diagnostic
-      ! -----------------------------------------------------
-      IF( l_trdtra ) THEN
+               ! anti-diffusive trends added to the general tracer trends
+               pta(ji,jj,jk) = pta(ji,jj,jk) - ( ztu(ji,jj,jk) - ztu(ji-1,jj  ,jk  )             &
+                  &                            + ztv(ji,jj,jk) - ztv(ji  ,jj-1,jk  )             &
+                  &                            + ztw(ji,jj,jk) - ztw(ji  ,jj  ,jk+1)  ) * zbtr
+            END DO
+         END DO
+      END DO
+
+      IF( l_trdtra ) THEN               ! trend diagnostic (contribution of anti-diffusive fluxes)
          CALL trd_tra_adv( kt, ktra, jpt_trd_xad, cdtype, ztu, pun, ptn, cnbpas='bis' )   ! <<< Add to iad trend
          CALL trd_tra_adv( kt, ktra, jpt_trd_yad, cdtype, ztv, pvn, ptn, cnbpas='bis' )   ! <<< Add to jad trend
          CALL trd_tra_adv( kt, ktra, jpt_trd_zad, cdtype, ztw, pwn, ptn, cnbpas='bis' )   ! <<< Add to zad trend
       ENDIF
-
+      !                                 ! "Poleward" heat and salt transports (contribution of anti-diffusive fluxes)
+      IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
+         IF( ktra == jp_tem)   pht_adv(:) = pht_adv(:) + ptr_vj( ztv(:,:,:) )
+         IF( ktra == jp_sal)   pst_adv(:) = pst_adv(:) + ptr_vj( ztv(:,:,:) )
+      ENDIF
+      !                                 ! control print
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=pta, clinfo1=' tvd - adv: ', mask1=tmask, clinfo3=cdtype )
       !
@@ -276,4 +247,5 @@
       zbetup(:,:,:) = 0.e0   ;   zbetdo(:,:,:) = 0.e0  
 
+!!gm   optimisation :  add the optimal version I wrote 1 year ago
       ! Search local extrema
       ! --------------------
